SHADER version 1
@OpenGL2.Vertex
#version 400
#define MAX_INSTANCES 256

//Variables
float wind_speed = 1.2;

//Uniforms
uniform instancematrices { mat4 matrix[MAX_INSTANCES];} entity;
uniform mat4 projectioncameramatrix;
uniform float currenttime;
float time = currenttime/1000;

//Attributes
in vec3 vertex_position;
in vec2 vertex_texcoords0;
in vec3 vertex_normal;
in vec3 vertex_binormal;
in vec3 vertex_tangent;

//Outputs
out vec2 ex_texcoords0;
out vec3 ex_normal;
out vec3 ex_tangent;
out vec3 ex_binormal;
out vec4 ex_vertexposition;

void main()
{
	mat4 entitymatrix = entity.matrix[gl_InstanceID];
	mat4 entitymatrix_=entitymatrix;
	entitymatrix_[0][3]=0.0;
	entitymatrix_[1][3]=0.0;
	entitymatrix_[2][3]=0.0;
	entitymatrix_[3][3]=1.0;
	
	ex_vertexposition = entitymatrix_ * vec4(vertex_position,1.0);

	//Wind
	//---------------------------------------------------------------------------
	if (vertex_position.y > 0.4) {
		ex_vertexposition.x += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.01) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.01));
		ex_vertexposition.z += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.01) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.01));
	}

	if (vertex_position.y > 0.8) {
		ex_vertexposition.x += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.015) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.015));
		ex_vertexposition.z += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.015) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.015));
	}

	if (vertex_position.y > 0.9) {
		ex_vertexposition.x += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.0152) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.0152));
		ex_vertexposition.z += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.0152) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.0152));
	}
	//--------------------------------------------------------------------------

	gl_Position = projectioncameramatrix * ex_vertexposition;
	
	mat3 nmat = mat3(entitymatrix);
	ex_normal = normalize(nmat * vertex_normal);
	ex_tangent = normalize(nmat * vertex_tangent);
	ex_binormal = normalize(nmat * vertex_binormal);
	
	ex_texcoords0 = vertex_texcoords0;
}
@OpenGLES2.Vertex

@OpenGLES2.Fragment

@OpenGL4.Vertex
#version 400
#define MAX_INSTANCES 256

//Variables
float wind_speed = 1.2;

//Uniforms
uniform instancematrices { mat4 matrix[MAX_INSTANCES];} entity;
uniform mat4 projectioncameramatrix;
uniform float currenttime;
float time = currenttime/1000;

//Attributes
in vec3 vertex_position;
in vec2 vertex_texcoords0;
in vec3 vertex_normal;
in vec3 vertex_binormal;
in vec3 vertex_tangent;

//Outputs
out vec2 ex_texcoords0;
out vec3 ex_normal;
out vec3 ex_tangent;
out vec3 ex_binormal;
out vec4 ex_vertexposition;

void main()
{
	mat4 entitymatrix = entity.matrix[gl_InstanceID];
	mat4 entitymatrix_=entitymatrix;
	entitymatrix_[0][3]=0.0;
	entitymatrix_[1][3]=0.0;
	entitymatrix_[2][3]=0.0;
	entitymatrix_[3][3]=1.0;
	
	ex_vertexposition = entitymatrix_ * vec4(vertex_position,1.0);

	//Wind
	//---------------------------------------------------------------------------
	if (vertex_position.y > 0.4) {
		ex_vertexposition.x += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.01) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.01));
		ex_vertexposition.z += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.01) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.01));
	}

	if (vertex_position.y > 0.8) {
		ex_vertexposition.x += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.015) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.015));
		ex_vertexposition.z += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.015) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.015));
	}

	if (vertex_position.y > 0.9) {
		ex_vertexposition.x += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.0152) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.0152));
		ex_vertexposition.z += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.0152) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.0152));
	}
	//--------------------------------------------------------------------------

	gl_Position = projectioncameramatrix * ex_vertexposition;
	
	mat3 nmat = mat3(entitymatrix);
	ex_normal = normalize(nmat * vertex_normal);
	ex_tangent = normalize(nmat * vertex_tangent);
	ex_binormal = normalize(nmat * vertex_binormal);
	
	ex_texcoords0 = vertex_texcoords0;
}
@OpenGL4.Fragment
#version 400
#define BFN_ENABLED 1

//Variables
vec4 diffuse_hue = vec4(0.8,0.8,0.8,1.0);
float diffuse_brightness = 1.0;

//Uniforms
uniform sampler2D texture0;//diffuse map
uniform sampler2D texture1;//normal map
uniform sampler2D texture2;//specular map

//Inputs
in vec2 ex_texcoords0;
in vec3 ex_normal;
in vec3 ex_tangent;
in vec3 ex_binormal;
in vec4 ex_vertexposition;

//Outputs
out vec4 fragData0;
out vec4 fragData1;
out vec4 fragData2;

void main(void)
{

	//Diffuse
	vec4 outcolor = texture(texture0,ex_texcoords0);
	
	//Specular
	vec4 color_specular = texture(texture2,ex_texcoords0);
	
	//Normal
	vec3 normal = ex_normal;
	normal = normalize(texture(texture1,ex_texcoords0).xyz * 2.0 - 1.0);
	normal.z /= 0.5;
	normal = ex_tangent * normal.x + ex_binormal * normal.y + ex_normal * normal.z;
	normal = normalize(normal);

	//Output
	fragData0 = outcolor * diffuse_hue * diffuse_brightness;

	//Normals
	fragData1 = vec4(normalize(normal)*0.5+0.5,fragData0.a);
	fragData1.a = 1/255.0;
	
	//Specular
	float specular = color_specular.r * 0.299 + color_specular.g * 0.587 + color_specular.b * 0.114;
	fragData2 = vec4(0,0,0, specular);
}
