SHADER version 1
@OpenGL2.Vertex
#version 400
#define MAX_INSTANCES 256

//Variables
float wind_speed = 1.2;

//Uniforms
uniform mat4 projectioncameramatrix;
uniform instancematrices { mat4 matrix[MAX_INSTANCES];} entity;
uniform sampler2D texture3;
uniform float currenttime;
float time = currenttime/1000;

//Attributes
in vec3 vertex_position;
in vec2 vertex_texcoords0;

out vec2 ex_texcoords0;

void main()
{
	mat4 entitymatrix = entity.matrix[gl_InstanceID];
	mat4 entitymatrix_=entitymatrix;
	entitymatrix_[0][3]=0.0;
	entitymatrix_[1][3]=0.0;
	entitymatrix_[2][3]=0.0;
	entitymatrix_[3][3]=1.0;
	
	ex_texcoords0 = vertex_texcoords0;

	vec4 ex_vertexposition = entitymatrix_ * vec4(vertex_position,1.0);

	//Wind
	//---------------------------------------------------------------------------
	if (vertex_position.y > 0.3) {
		ex_vertexposition.x += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.01) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.01));
		ex_vertexposition.z += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.01) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.01));
	}
	//--------------------------------------------------------------------------

	gl_Position = projectioncameramatrix * ex_vertexposition;
}
@OpenGLES2.Vertex

@OpenGLES2.Fragment

@OpenGL4.Vertex
#version 400
#define MAX_INSTANCES 256

//Variables
float wind_speed = 1.2;

//Uniforms
uniform mat4 projectioncameramatrix;
uniform instancematrices { mat4 matrix[MAX_INSTANCES];} entity;
uniform sampler2D texture3;
uniform float currenttime;
float time = currenttime/1000;

//Attributes
in vec3 vertex_position;
in vec2 vertex_texcoords0;

out vec2 ex_texcoords0;

void main()
{
	mat4 entitymatrix = entity.matrix[gl_InstanceID];
	mat4 entitymatrix_=entitymatrix;
	entitymatrix_[0][3]=0.0;
	entitymatrix_[1][3]=0.0;
	entitymatrix_[2][3]=0.0;
	entitymatrix_[3][3]=1.0;
	
	ex_texcoords0 = vertex_texcoords0;

	vec4 ex_vertexposition = entitymatrix_ * vec4(vertex_position,1.0);

	//Wind
	//---------------------------------------------------------------------------
	if (vertex_position.y > 0.3) {
		ex_vertexposition.x += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.01) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.01));
		ex_vertexposition.z += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.01) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.01));
	}
	//--------------------------------------------------------------------------

	gl_Position = projectioncameramatrix * ex_vertexposition;
}
@OpenGL4.Fragment
#version 400

float leaf_size = 1.0;

uniform sampler2D texture0;

in vec2 ex_texcoords0;

void main()
{
	float shadow = texture(texture0,ex_texcoords0*leaf_size).a;
	if (shadow < 0.8) discard;
}
