SHADER version 1
@OpenGL2.Vertex
#version 400
#define MAX_INSTANCES 256

//Variables
float wind_speed = 1.2;

//Uniforms
uniform instancematrices { mat4 matrix[MAX_INSTANCES];} entity;
uniform mat4 projectioncameramatrix;
uniform float currenttime;
float time = currenttime/1000;

//Attributes
in vec3 vertex_position;
in vec2 vertex_texcoords0;
in vec3 vertex_normal;
in vec3 vertex_tangent;
in vec3 vertex_binormal;

//Outputs
out vec2 ex_texcoords0;
out vec3 ex_normal;
out vec3 ex_tangent;
out vec3 ex_binormal;
out vec3 ex_light;
out vec4 ex_vertexposition;

void main()
{
	mat4 entitymatrix = entity.matrix[gl_InstanceID];
	mat4 entitymatrix_=entitymatrix;
	entitymatrix_[0][3]=0.0;
	entitymatrix_[1][3]=0.0;
	entitymatrix_[2][3]=0.0;
	entitymatrix_[3][3]=1.0;

	ex_vertexposition = entitymatrix_*vec4(vertex_position,1.0);

	//Wind
	//---------------------------------------------------------------------------
	if (vertex_position.y > 0.15) {
		ex_vertexposition.x += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.02) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.02));
		ex_vertexposition.z += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.02) + (cos(2.0 * ex_vertexposition.z + (time*wind_speed)) * 0.02));
	}

	if (vertex_position.y > 0.19) {
		ex_vertexposition.x += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.03) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.04));
		ex_vertexposition.z += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.03) + (cos(2.0 * ex_vertexposition.z + (time*wind_speed)) * 0.04));
	}
	//--------------------------------------------------------------------------

	gl_Position = projectioncameramatrix * ex_vertexposition;


	mat3 nmat = mat3(entitymatrix_);
	ex_normal = normalize(nmat*vertex_normal);
	ex_tangent = normalize(nmat*vertex_tangent);
	ex_binormal = normalize(nmat*vertex_binormal);
	ex_light = normalize(nmat * vertex_position);
	
	ex_texcoords0 = vertex_texcoords0;

}
@OpenGLES2.Vertex

@OpenGLES2.Fragment

@OpenGL4.Vertex
#version 400
#define MAX_INSTANCES 256

//Variables
float wind_speed = 1.2;

//Uniforms
uniform instancematrices { mat4 matrix[MAX_INSTANCES];} entity;
uniform mat4 projectioncameramatrix;
uniform float currenttime;
float time = currenttime/1000;

//Attributes
in vec3 vertex_position;
in vec2 vertex_texcoords0;
in vec3 vertex_normal;
in vec3 vertex_tangent;
in vec3 vertex_binormal;

//Outputs
out vec2 ex_texcoords0;
out vec3 ex_normal;
out vec3 ex_tangent;
out vec3 ex_binormal;
out vec3 ex_light;
out vec4 ex_vertexposition;

void main()
{
	mat4 entitymatrix = entity.matrix[gl_InstanceID];
	mat4 entitymatrix_=entitymatrix;
	entitymatrix_[0][3]=0.0;
	entitymatrix_[1][3]=0.0;
	entitymatrix_[2][3]=0.0;
	entitymatrix_[3][3]=1.0;

	ex_vertexposition = entitymatrix_*vec4(vertex_position,1.0);

	//Wind
	//---------------------------------------------------------------------------
	if (vertex_position.y > 0.15) {
		ex_vertexposition.x += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.02) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.02));
		ex_vertexposition.z += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.02) + (cos(2.0 * ex_vertexposition.z + (time*wind_speed)) * 0.02));
	}

	if (vertex_position.y > 0.19) {
		ex_vertexposition.x += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.03) + (cos(2.0 * ex_vertexposition.x + (time*wind_speed)) * 0.04));
		ex_vertexposition.z += ((sin(2.0 * ex_vertexposition.y + (time*wind_speed)) * 0.03) + (cos(2.0 * ex_vertexposition.z + (time*wind_speed)) * 0.04));
	}
	//--------------------------------------------------------------------------

	gl_Position = projectioncameramatrix * ex_vertexposition;


	mat3 nmat = mat3(entitymatrix_);
	ex_normal = normalize(nmat*vertex_normal);
	ex_tangent = normalize(nmat*vertex_tangent);
	ex_binormal = normalize(nmat*vertex_binormal);
	ex_light = normalize(nmat * vertex_position);
	
	ex_texcoords0 = vertex_texcoords0;

}
@OpenGL4.Fragment
//from http: www.gamedev.net/community/forums/topic.asp?topic_id=481494
//from https://www.youtube.com/watch?v=RPkhbjmmvS0

#version 400

//Variables
vec3 lightpos = vec3(0.5,0.5,-0.5);
vec3 hue = vec3(0.8,1.0,0.8);
float gradient_contrast = 2.0;
float back_light = 0.7;
float diffuse_brightness = 0.8;
float specular = 0.25;

//Uniforms	
uniform sampler2D texture0;//diffuse
uniform sampler2D texture1;//normal
uniform sampler2D texture2;//specular
uniform vec3 cameraposition;
uniform mat4 projectionmatrix;

//Inputs
in vec4 ex_vertexposition;
in vec2 ex_texcoords0;
in vec3 ex_normal;
in vec3 ex_tangent;
in vec3 ex_binormal;
in vec3 ex_light;

out vec4 fragData0;
out vec4 fragData1;
out vec4 fragData2;

void main() {

	//Diffuse 
	vec4 outcolor = texture(texture0, ex_texcoords0) * diffuse_brightness;
	if (outcolor.a < 0.5) discard;

	//Specular 
	vec4 color_specular = texture(texture2,ex_texcoords0);
	
	//Normal
	vec3 normal = ex_normal;
	normal = normalize(texture(texture1,ex_texcoords0).xyz * 2.0 - 1.0);
	normal.z /=2.0;
	normal = ex_tangent * normal.x + ex_binormal * normal.y + ex_light * normal.z;
	normal = normalize(normal);

	//Subsurface scattering (pseudo)
	vec3 lightvec = normalize(projectionmatrix[3].xyz - lightpos);
	vec3 eyevec = normalize(ex_vertexposition.xyz - cameraposition);
	float subsurface = dot(eyevec,lightvec + normal * 0.5);
	float ndotv = max(0.7,pow(1-dot(-ex_light,eyevec),0.5));
	
	//Gradient
	float gradient = 1-abs(sin(ex_texcoords0.x * 3.0) * sin(1.0-ex_texcoords0.y * 3.0));
	gradient *= 1-subsurface;
	outcolor.xyz *= mix(hue, outcolor.xyz * gradient * gradient_contrast,0.5);
	
	//Output
	fragData0 = outcolor;

	//Normals Output
	fragData1 = vec4(normalize(normal)*0.5+0.5,fragData0.a);
	fragData1.a = 1/255.0;

	//Specular Output
	fragData2 = vec4(mix(outcolor.xyz*ndotv*back_light,outcolor.xyz,subsurface),specular);
}
